// 07/ sept 2015
// activation IT timer0 1sec ..BAD ??
// confusion entre INTCON.TMR0IF  et INTCON.T0IF     Raz du  Flag
//
// 06 sept 2015
/// version avec UART1 only
// rajou erase ligne , cls , fonction ecriture texte
// la 1ere ligne LCD affiche la mesure de l'ADC voie RA0
// la 2em ligne LCD affiche le message recu par UART1
//
//  05/09/2015
// Probleme
// des que j'init I2C1 , le programme se plante
// meme le clignotement de led ..au debut du programme ne mmarche pas
// encore moins les sorties UART1 et UART2
// enlev la partie juste apres I2C1 init
// => leds OK et UART1 UART2  OK
// 0 1144 Used ROM (bytes): 17191 (52%) 
//   Free ROM (bytes): 15577 (48%) 
// je suspecte un debordement de RAM because usage du bootloader!
// => message en Flasch au lieu de RAM
// probleme localis sur check_device(unsigned char dev_address)
// qui utilise sprintf .. tres consommateur de ressources !
// et ce PIC est bien moins costaud que le 18F87J50 ou 18F46K22

// inverseur POWER  mettre cot 3,3V
// Ready for PIC 18F45K22 board
// I2C sur LCD 2119
// UART1
/*  Directory :    C:\_MikroC\_MesProjets_MikroC\_18F45K22_ReadyForPic\
    Projet :       18F45K22_UART_LCD2119.mcppi
    source:        18F45k22_Uart1_ADC0_LCD_2119_I2C_150906.c
    FOSC           Q=8Mhz x 4 (PLL) => 32MHZ OBLIGATOIRE pour le bootloader
    Hardware :     Ready for PIC 18F45K22
    Power supply:  SUPPLY SELECT SWITH on 3.3V
    RS232          UART1 19200,8,N,1 --- FTDI--USB__terminal virtuel COM23    Windows 8.1
    LCD            : LCD2119 2x16 cars  I2C link  2 wires
    LED            LED + 390 ohms on RA4 output
 
 P18F45K22_Q8Mhz_PLLx4_32Mhz.cfgsch
CONFIG1H : $300001 : 0x00B3
CONFIG2L : $300002 : 0x0018
CONFIG2H : $300003 : 0x003C
CONFIG3H : $300005 : 0x00BD
CONFIG4L : $300006 : 0x0081
CONFIG5L : $300008 : 0x000F
CONFIG5H : $300009 : 0x00C0
CONFIG6L : $30000A : 0x000F
CONFIG6H : $30000B : 0x00E0
CONFIG7L : $30000C : 0x000F
CONFIG7H : $30000D : 0x0040



*/
#include "built_in.h"

#define Version "07-09-2015 b"
//#define FOSC_Interne

 //-- commandes terminal VT220
#define CLS 12     // effacement de page sur Terminal VBRAY
#define CR 13
#define VT 10
#define LF 10
#define TAB 9
#define Bell 7
#define Byte unsigned char

 //          12345678901234567890
const char chaine0[]="18F45k22 Ready for PIC : Test LCD 2119 2x16 en I2C\r\n ";
const char chaine1[]="MikroC Pro v 6.50   Q=8MHZ x PLL => 32MHz  \r\n";
const char chaine2[]="Projet : 18F45K22_UART_LCD2119.mcppi\r\n";
const char chaine3[]="Source : 18f45k22_uart1_LCD2119_150906.c\r\n";
const char chaine4[]="UARTY1 <-> FTDI <-> Virtual port COM23 \r\n";
const char *RS_Str[]={chaine0,chaine1,chaine2,chaine3,chaine4};

char TEXTE[64];
char CRam1[24];
char *txt;
unsigned int i,j,k,l,m;
char dummy;

unsigned int Flag_Timer0;
unsigned int Cpt0;
unsigned int EAx,EA0;

#define MAXLEN1 80
unsigned char buffer1[MAXLEN1];
unsigned int Index1,i1;
unsigned int UART1_DataReady;
unsigned char c1;

unsigned char LCD_ADR;
unsigned int Ncycles ;
unsigned long Freq;

char Table[17];


sbit LED_RA4 at LATA4_bit;
sbit LED_RA4_Direction at TRISA4_bit;

int LCD2119_Init(void);
void RAZ_UART1(void);
void Init_Timer0(void);
void UART1_Write_CText(const char *txt1);
void strConstRamCpy(char *dest, const char *source);
void CRLF1(void);
void LCD_CLS(void);
void LCD_Clear(void); // <-- PB >> au lieu de space..  suivre
int LCD2119_Init(void);
void LCD_RAZ_Ligne(int L);
void LCD_Write_Text(unsigned int Ligne,char * t1);
void check_device(unsigned char dev_address);


// interrupt handler
void Interrupts() iv 0x0008 ics ICS_AUTO
{
//  UART2
    if((RC1IF_bit==1) && (RC1IE_bit==1))
    {
      if(OERR1_bit)
      {
          CREN1_bit = 0; 
          OERR1_bit = 0;
          CREN1_bit = 1;
       }
      if(FERR1_bit==1)   c1 = RCREG1;
      c1 =RCREG1;  //UART2_Read();
      if ((c1==CR)|| (i1>=MAXLEN1))
      {
       UART1_DataReady=1;
       if (i1 >= MAXLEN1) UART1_DataReady=2;
       PIE2.RC1IE=0 ; //interdit IT Reception UART
       buffer1[i1]=0;
       Index1=i1;
       i1=0;
       c1=0;
      }
       else
      {
        buffer1[i1]=c1;
        Index1=i1;
        i1++;
      }
    }

   //   ====  IT Timer0  =============
   if((INTCON.TMR0IE) && (TMR0IF_bit))
   {
    // Cpt0++;
   // if(Cpt0>0)  // 1 seconde
   //  {
      T0CON.TMR0ON=0;
      Flag_Timer0=1;
      TMR0IE_bit=0;
    //  Cpt0=0;
    //  }
     TMR0IF_bit=0; // Raz Flag
   }
  #ifdef Wit_HID
  USB_Interrupt_Proc();           // for HID
  #endif
}

 void RAZ_UART1()
{      int i;
      for (i=0;i<MAXLEN1;i++) buffer1[i]=0;
      Index1=0;
      i1=0;
      UART1_DataReady=0;
      c1=RCREG1; 
      PIE1.RC1IE=1 ;
      c1=0;
}

 void Init_Timer0()
{
 //--- init timer0 en mode 16 bits
 //see PIC18F25K22_45K22_41412E.pdf  11.11 page 159
  T0CON.PSA=0;      // Timer0 prescaler assigned to Clock
  T0CON.T0PS2=1;    //
  T0CON.T0PS1=1;    //
  T0CON.T0PS0=1;    // prescler =>111 => 1/256
  T0CON.T0CS=0;     // internal cycle clock
  T0CON.T08BIT=0 ;  // Mode 16 bits
 // 1sec at 48MHz et prescaler=256
 // TMR0H= 0x48; // Hi 18661;
//  TMR0L =0xE5 ; // Lo 18661;
 // 1sec at 32MHz et prescaler=256
//  TMR0H= Hi(Ncycles);
//  TMR0L =Lo(Ncycles);
 TMR0H= 0x85; // Hi 34256;
 TMR0L =0xD0 ; // Lo 34256;
// 18661 prescaler =256 1sec at 48MHz  48E5
// 28036 prescaler=32 48MHz => 100mS  6D84
// 3035 prescaler =128  0,5sec @64Mhz
// 3035  prescaler=128  2sec at 16Mhz
// 34286  prescaler=128  1,0sec at 16Mhz    85EE
// 26456   prescaler=128 1sec at 20Mhz
// 34256  0085D0  prescaler =256 1sec at 32Mhz

  Cpt0=0;
  Flag_Timer0=0;
  INTCON2.TMR0IP=1;
  TMR0IF_bit=0;    // raz flag interrupt
  INTCON.TMR0IE=1;
  T0CON.TMR0ON=1;
}


void UART1_Write_CText(const char *txt1)
 {
   while (*txt1)
      UART1_Write(*txt1++);
}

// --- Copie le texte depuis ROM vers RAM
void strConstRamCpy(char *dest, const char *source) 
{
  while(*source) *dest++ = *source++ ;
  *dest = 0 ;    // terminateur
}

void CRLF1()
{
 UART1_Write(CR);
  UART1_Write(LF);
 }
void LCD_CLS()
{
// d'abord la ligne 2 pour avoir le curseur en 0 de ligne 1
LCD_RAZ_Ligne(2);
LCD_RAZ_Ligne(1);
}

void LCD_Clear()
{
 // problematique ?
 //  suivre...
int j;
I2C1_Start();
j=I2C1_Wr(LCD_ADR); // i2c slave Address
j=I2C1_Wr(0x00);    // Control byte for Instruction
j=I2C1_Wr(0x80); // DDRAM Address set to 00hex
j=I2C1_Wr(0x02); // return home
j=I2C1_Wr(0x01); // clear display
I2C1_Stop();
}


int LCD2119_Init(void)
{
int j,k;
k=0;
Delay_ms(500);
I2C1_Start();
j=I2C1_Wr(LCD_ADR); // i2c slave Address
if (j!=0) return k;
k++;
Delay_ms(100);
j=I2C1_Wr(0x00);    // Control byte for Instruction
if (j>0) return k;
k++;
I2C1_Wr(0x34);    // DL: 8 bits, M: 16 by two line display, SL: 1:18, H: normal instruction set
I2C1_Wr(0x0C); // D: Display on, C: curser off, B: blink off
I2C1_Wr(0x06);    // I/D: increment, S: no shift
I2C1_Wr(0x35); // DL: 8 bits, M: 16 by two line, SL: 1:18, H: extended instruction set
//I2C1_Wr(0x04); // P: left to right, Q: top to bottom    sur connecteur A
I2C1_Wr(0x06); // P: Right to left ,Q: top to bottom      sur connecteur B
I2C1_Wr(0x11); // TC1: 0, TC0: 1
I2C1_Wr(0x42); // HV Stages 3
//I2C1_Wr(0x9f); // set Vlcd, store to VA
I2C1_Wr(0x96); // set Vlcd, store to VA
j=I2C1_Wr(0x34); // DL: 8 bits, M: two line, SL: 1:18, H: normal instruction set
if (j>0) return k;
k++;
j=I2C1_Wr(0x80); // DDRAM Address set to 00hex
if (j>0) return k;
k++;
j=I2C1_Wr(0x02); // return home
if (j>0) return k;
k++;
j=I2C1_Wr(0x01); // clear display
if (j>0) return k;
k++;
I2C1_Stop();
return k;
}

void LCD_RAZ_Ligne( int L)
{
 I2C1_Start();
 I2C1_Wr(LCD_ADR); // i2c slave Address
 I2C1_Wr(0x00); // Control byte for Instruction
 I2C1_Wr(0x02); // return home
 switch (L)
 {
  case 1:
      I2C1_Wr(0x80); // DDRAM Address 1ere ligne
      break;
  case 2:
      I2C1_Wr(0xC0); // DDRAM Address 2em ligne
      break;
  default:
  break ;
 }
 I2C1_Repeated_Start();
 I2C1_Wr(LCD_ADR); // i2c slave Adress
 I2C1_Wr(0x40);     // Control byte for Data
 for (i=0;i<39;i++)
 {
   I2C1_Wr(0x80+32); // efface avec des blanc
 }
 // repositionne au debut de ligne
 I2C1_Repeated_Start();
 I2C1_Wr(LCD_ADR); // i2c slave Adress
 I2C1_Wr(0x00); // Control byte for Instruction
 //I2C1_Wr(0x40);     // Control byte for Data
 switch (L)
  {
   case 1:
         I2C1_Wr(0x80); // DDRAM Address 1ere ligne
        break;
   case 2:
        I2C1_Wr(0xC0); // DDRAM Address 2em ligne
        break;
   default:
        break ;
  }
 I2C1_Stop();
}

void LCD_Write_Text(unsigned int Ligne,char * t1)
{
int i;
I2C1_Start();
I2C1_Wr(LCD_ADR); // i2c slave Address
I2C1_Wr(0x00); // Control byte for Instruction
switch (Ligne)
{
  case 1:
      I2C1_Wr(0x80); // DDRAM Address 1ere ligne
      break;
  case 2:
      I2C1_Wr(0xc0); // DDRAM Address 2em ligne
        break;
  default:
  break ;
}
I2C1_Repeated_Start();
I2C1_Wr(LCD_ADR); // i2c slave Adress
I2C1_Wr(0x40); // Control byte for Data
i=0;
while(*(t1))
{
  I2C1_Wr(0x80+*(t1));
  t1++;
  i++;
  if (i>16) break;
}
I2C1_Stop();
}

void upside_down(void)
{
I2C1_Start();
I2C1_Wr(LCD_ADR);
I2C1_Wr(0x00); // Control byte for Instruction
I2C1_Wr(0x35); // DL: 8 bits, M: 16 by two line, SL: 1:18, H: extended instruction set
//I2C1_Wr(0x07); // P=1; Q=1;
I2C1_Wr(0x04); // P=1; Q=0;
I2C1_Stop();
}

void normal(void)
{
I2C1_Start();
I2C1_Wr(LCD_ADR);
I2C1_Wr(0x00); // Control byte for Instruction
I2C1_Wr(0x35); // DL: 8 bits, M: 16 by two line, SL: 1:18, H: extended instruction set
//I2C1_Wr(0x04); // P=1; Q=0;
I2C1_Wr(0x06); // P=1; Q=1;
I2C1_Stop();
}

void check_device(unsigned char dev_address)
{
strConstRamCpy(txt,"Device at adresse : ");
k=strlen(txt);
ByteToStr(dev_address,CRam1);
strcat(txt+k,CRam1);
UART1_Write_Text(txt);
I2C1_Start();
if(I2C1_Wr(dev_address)!=0 )
 {
  UART1_Write_CText(" is not found");
 }
 else
 {
  UART1_Write_CText(" found OK");
  }
I2C1_Stop();
 CRLF1();
}

void main ()
{
#ifdef FOSC_Interne
//OSCCON = 0b01100010  ; //0x72 ;     //Oscillateur  8Mhz
OSCCON=0;
OSCCON.IRCF2=1;    // 111 => 16MHz   110=> 8MHz 101 => 4Mhz
OSCCON.IRCF2=1;
OSCCON.IRCF2=0;
OSCCON.SCS1=1;  // internal Oscillator seleted
OSCTUNE=0;
OSCTUNE.PLLEN=1;
while (OSCCON.HFIOFS==0); // wait stable oscillator
#else
// Q=8Mhz  avec PLL=1 => 32 Mhz
#endif

  C1ON_bit = 0;               // Disable comparators
  C2ON_bit = 0;
  TRISA=0b11101111 ;   // RA4 as output  RA0,1,2,3,5=input
  ANSELA=0x01;   // RA0 as analog
  LED_RA4_Direction=0;
  ANSELB=0;
  ANSELE=0;    
  TRISC=0b10111101 ; //RC1 output ,RC3,RC4 as input
//  TRISC=0b10100101 ; //RC1 ,RC3,RC4 as output   .. OK
   ANSELC=0;
  TRISD=0b10111111 ;
  ANSELD=0;
  
  txt=&TEXTE[0];

   // Select Vref and analog inputs, in order to use ADC_Read
  ADCON0 = 0x01;     // All porta pins as analog, VDD as Vref
  ADCON1 = 0 ;       // refences sur +3,3V et Ground
  ADCON2.ADFM=1 ;    // right justified
  ADCON2.ACQT2 = 1;  // 8 TAD
  ADCON2.ACQT1 = 0;
  ADCON2.ACQT0 = 0;
  ADCON2.ADCS2= 0;   // FOsc/32
  ADCON2.ADCS1= 1;
  ADCON2.ADCS0= 0;
  ADC_Init();
 // pour tester FOSC
 j=0;
 while(j<5)
 {
  LATA4_bit=0;
  Delay_ms(500);
  LATA4_bit=1;
  Delay_ms(500);
  j++;
 }
  LED_RA4=0;
  UART1_Init(19200);
  while (UART1_Tx_Idle() == 0) ;
  UART1_Write(CLS);
  // presentation
  UART1_Write_CText(" Version : "Version"\r\n");
  for (i=0;i<3;i++)
  {
  UART1_Write_CText(RS_Str[i]);
  }
  
  Freq = Clock_kHz();
  UART1_Write_CText(" Fosc =");
  LongWordToStr(Freq, txt) ;
  UART_Write_Text(txt);
  UART1_Write_CText(" KHz\r\n");
  

  UART1_Write_CText(" Init I2C1 100Khz\r\n");
 
  I2C1_Init(100000); // Initialisation de l'I2C
  Delay_ms(100);
  // verif presence du LCD sur le bus I2C
  LCD_ADR=0x74;
  check_device(LCD_ADR) ;
   UART1_Write_CText(" Init Display LCD2119\r\n");
   m=0;
   m= LCD2119_Init();
   WordToStr(m,txt);
   UART1_Write_CText(" Nb Step = "); // 6 steps=OK
   UART1_Write_Text(txt);
   CRLF1();

  UART1_Write_CText("Ecriture sur 1ere ligne du LCD : ");
  strConstRamCpy(txt,"ABCDEFGHIJKLMNOPQ");
  UART1_Write_Text(txt);
  CRLF1();
  LCD_Write_Text(1,txt);

  UART1_Write_CText("Ecriture sur 2em ligne du LCD : ");
  strConstRamCpy(txt,"paulfjujo 0123456789");
  UART1_Write_Text(txt);
  CRLF1();
  LCD_Write_Text(2,txt);  // nota : texte limit  16 cars !
  Delay_ms(2000);
  
  RAZ_UART1();
  // arme interruptions UART2 RX
  PIE3.RC1IE=1 ;
  IPR3.RC1IP=1;
  RCON.IPEN=1;
  RC1IE_bit =1;    // Enable UART RX interrupt
  PEIE_bit = 1;    // Enable Peripheral interrupt
  GIE_bit  = 1;
  j=0;
  k=1;
  

  while(1)
  {
    Init_Timer0();
    LED_RA4 = ! LED_RA4;   // Pour verifier que le programme tourne
    if (UART1_DataReady==1)
    { 

      LCD_RAZ_Ligne(2);
      UART1_Write_CText("Ecriture sur Ligne 2");
      CRLF1();
      buffer1[16]=0;
      LCD_Write_Text(2,buffer1);
      RAZ_UART1(); // efface buffer1
    }
    j++;
    if(j>9)
    {
      LCD_CLS();
      UART1_Write_CText("LCD_CLS() \r\n");
      j=0;
     }
     strConstRamCpy(txt,"Mes.  ADC0=");
     *(txt+4)=j + 48;
     k=strlen(txt);
     EA0=ADC_Read(0);
     WordToStr(EA0,CRam1);
     strcat(txt,CRam1);
     LCD_Write_Text(1,txt);
     UART1_Write_Text(txt);CRLF1();
     while(Flag_Timer0==0);     // delai 1 sec
  }

}

/*
***********************************************
 Version : 07-09-2015 b
18F45k22 Ready for PIC : Test LCD 2119 2x16 en I2C
 MikroC Pro v 6.50   Q=8MHZ x PLL => 32MHz
Projet : 18F45K22_UART_LCD2119.mcppi
 Fosc =     32000 KHz
 Init I2C1 100Khz
Device at adresse : 116 found OK
 Init Display LCD2119
 Nb Step =     6
Ecriture sur 1ere ligne du LCD : ABCDEFGHIJKLMNOPQ
Ecriture sur 2em ligne du LCD : paulfjujo 0123456789
Mes.1 ADC0=  142
Mes.2 ADC0=  142
Mes.3 ADC0=  142
Mes.4 ADC0=  142
Mes.5 ADC0=  142
Mes.6 ADC0=  142

*******************************

0 1 mikroCPIC1618.exe -MSF -DBG -pP18F45K22 -RA -C -O11111004 -fo32 -N"C:\_MikroC\_MesProjets_MikroC\_18F45K22_ReadyForPic\18F45K22_UART1_ADC0_LCD_2119_I2C.mcppi" -EH"C:\_MikroC\_MesProjets_MikroC\_18F45K22_ReadyForPic\18F45K22_UART_LCD2119-eeprom.ihex" -SP"C:\_MikroC\mikroC PRO for PIC\defs\" -SP"C:\_MikroC\mikroC PRO for PIC\uses\P18\" -SP"C:\_MikroC\_MesProjets_MikroC\_18F45K22_ReadyForPic\" "18F45k22_Uart1_ADC0_LCD_2119_I2C_150906.c" "__Lib_Math.mcl" "__Lib_MathDouble.mcl" "__Lib_System.mcl" "__Lib_Delays.mcl" "__Lib_CType.mcl" "__Lib_CString.mcl" "__Lib_CStdlib.mcl" "__Lib_Conversions.mcl" "__Lib_ADC_A_D.mcl" "__Lib_I2C_c34d01.mcl" "__Lib_UART_c67d67.mcl"
0 1139 Available RAM: 1515 [bytes], Available ROM: 32768 [bytes]
0 122 Compilation Started P18F45K22.c
2774 123 Compiled Successfully P18F45K22.c
0 122 Compilation Started __Lib_Delays.c
172 123 Compiled Successfully __Lib_Delays.c
0 122 Compilation Started 18F45k22_Uart1_ADC0_LCD_2119_I2C_150906.c
0 1004 interrupt handler (Interrupts at 0x0008) 18F45k22_Uart1_ADC0_LCD_2119_I2C_150906.c
521 123 Compiled Successfully 18F45k22_Uart1_ADC0_LCD_2119_I2C_150906.c
226 1164 Variable 'j' has been eliminated by optimizer 18F45k22_Uart1_ADC0_LCD_2119_I2C_150906.c
0 127 All files Compiled in 47 ms
0 1144 Used RAM (bytes): 243 (16%)  Free RAM (bytes): 1272 (84%) Used RAM (bytes): 243 (16%)  Free RAM (bytes): 1272 (84%)
0 1144 Used ROM (bytes): 3906 (12%)  Free ROM (bytes): 28862 (88%) Used ROM (bytes): 3906 (12%)  Free ROM (bytes): 28862 (88%)
0 125 Project Linked Successfully 18F45K22_UART1_ADC0_LCD_2119_I2C.mcppi
0 128 Linked in 31 ms
0 129 Project '18F45K22_UART1_ADC0_LCD_2119_I2C.mcppi' completed: 187 ms
0 103 Finished successfully: 07 sept. 2015, 16:37:15 18F45K22_UART1_ADC0_LCD_2119_I2C.mcppi
                */